function aabb(x1,y1,w1,h1, x2,y2,w2,h2)
    return x1 < x2+w2 and
           x2 < x1+w1 and
           y1 < y2+h2 and
           y2 < y1+h1
end

function collide(x1, y1, z1, w1, h1, d1, x2, y2, z2, w2, h2, d2)
    if not aabb(x1, y1, w1, h1, x2, y2, w2, h2) then
        return false, 0, 0, 0
    end
    local vx = x1 + w1 * .5 - x2 - w2 * .5
    local vy = y1 + h1 * .5 - y2 - h2 * .5
 
    vx = vx > 0 and x2 + w2 - x1 or x2 - x1 - w1
    vy = vy > 0 and y2 + h2 - y1 or y2 - y1 - h1
    local xAxis = math.abs(vx) < math.abs(vy)
 
    return true, xAxis and vx or 0, xAxis and 0 or vy
end